> For the complete documentation index, see [llms.txt](https://www.cakewalk.security/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://www.cakewalk.security/docs/open-api-and-mcp/api-reference/requests/post-requests-grantaccess.md).

# POST /Requests/GrantAccess

## POST /api/v1/Requests/GrantAccess

> Creates a grant access request.

```json
{"openapi":"3.0.4","info":{"title":"Cakewalk Open API","version":"v1"},"servers":[{"url":"https://open-api.getcakewalk.io"}],"security":[{"API Key":[]}],"components":{"securitySchemes":{"API Key":{"type":"apiKey","description":"Public API key used to identify the client application. It should be included in all requests.","name":"X-API-KEY","in":"header"}},"schemas":{"CreateGrantAccessRequestRequestV1":{"required":["createdByUserId","grantAccessPurpose","targetUserId","workAppId"],"type":"object","properties":{"createdByUserId":{"type":"string","description":"User that appears as creator of the request.","format":"uuid"},"targetUserId":{"type":"string","description":"Identifier of the user who will receive access.","format":"uuid"},"workAppId":{"type":"string","description":"Identifier of the work app for which access is being requested.","format":"uuid"},"grantAccessPurpose":{"maxLength":1024,"minLength":1,"type":"string","description":"Purpose or reason for the grant access request."},"permissionLevelId":{"type":"string","description":"Optional identifier of the permission level to request. It is mandatory if the work app has at least one permission level.","format":"uuid","nullable":true}},"additionalProperties":false,"description":"Request to create a new grant access request."},"CreatedRequestResultViewModelV1":{"required":["requestId"],"type":"object","properties":{"requestId":{"minLength":1,"type":"string","description":"Unique identifier of the created request."}},"additionalProperties":false,"description":"Result of a successful request creation."},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}},"paths":{"/api/v1/Requests/GrantAccess":{"post":{"tags":["Requests"],"summary":"Creates a grant access request.","parameters":[{"name":"X-API-SECRET","in":"header","description":"API Secret is used to verify the integrity of the request and authenticate the client. It should be included in all requests. This value must be kept confidential and should never be exposed in client-side code or public repositories.","required":true,"schema":{"type":"string","description":"API Secret is used to verify the integrity of the request and authenticate the client. It should be included in all requests. This value must be kept confidential and should never be exposed in client-side code or public repositories."}}],"requestBody":{"description":"The request model used to create the grant access request.","content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/CreateGrantAccessRequestRequestV1"}],"description":"Request to create a new grant access request."}},"text/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/CreateGrantAccessRequestRequestV1"}],"description":"Request to create a new grant access request."}},"application/*+json":{"schema":{"allOf":[{"$ref":"#/components/schemas/CreateGrantAccessRequestRequestV1"}],"description":"Request to create a new grant access request."}}}},"responses":{"201":{"description":"Created","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/CreatedRequestResultViewModelV1"}},"application/json":{"schema":{"$ref":"#/components/schemas/CreatedRequestResultViewModelV1"}},"text/json":{"schema":{"$ref":"#/components/schemas/CreatedRequestResultViewModelV1"}}}},"400":{"description":"Bad Request","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"401":{"description":"Unauthorized","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"403":{"description":"Forbidden","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}},"text/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"500":{"description":"Internal Server Error"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://www.cakewalk.security/docs/open-api-and-mcp/api-reference/requests/post-requests-grantaccess.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
